=== debian/changelog ===
sc-membench (1.2.1-3) unstable; urgency=medium

  * d/control: drop libnuma-dev for hurd in build-depends.
  * Makefile: drop mtune=generic for other archs.

 -- Alex Myczko <tar@debian.org>  Sat, 28 Feb 2026 12:38:43 +0100

sc-membench (1.2.1-2) unstable; urgency=medium

  * d/control: improved to be more portable.
  * Bump standards version to 4.7.3.

 -- Alex Myczko <tar@debian.org>  Sat, 28 Feb 2026 10:55:40 +0100

sc-membench (1.2.1-1) unstable; urgency=medium

  * Initial release. (Closes: #1127553)

 -- Alex Myczko <tar@debian.org>  Mon, 09 Feb 2026 19:17:20 +0000
