=== debian/control ===
Source: sc-membench
Section: utils
Priority: optional
Maintainer: Alex Myczko <tar@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 libhwloc-dev,
 libudev-dev [!hurd-amd64 !hurd-i386],
 libnuma-dev [!hurd-amd64 !hurd-i386],
 libhugetlbfs-dev [!alpha !hppa !m68k !sh4 !x32],
 libopenmpi-dev [!i386 !armhf],
Standards-Version: 4.7.3
Homepage: https://github.com/SpareCores/sc-membench
Vcs-Browser: https://salsa.debian.org/debian/sc-membench
Vcs-Git: https://salsa.debian.org/debian/sc-membench.git

Package: sc-membench
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: modern memory bandwidth and latency benchmarks
 This is a portable, multi-platform memory bandwidth benchmark designed for
 comprehensive system analysis.
